var delim = "£";
var csInterface = new CSInterface();
var fs = require("fs");

// const OpenIndesign = require(`${__dirname}/openIndesign/dist/openIndesign.js`);
//var Client = require('ftp');    // pjb 10_23_17
var console = window.console;
var extensionRootPath = "";

$(function () {
  localStorage.ixApplicationName = "InDesign CC 2015";

  console.log("ixPanel.js ready start");

  console.log("index.js onload start");

  $(document).tooltip();

  localStorage.ixManifestVersion = "-";

  var flyoutXML =
    '\
	<Menu> \
		<MenuItem Id="MENU_SHOW_HELP" Label="Help" Enabled="true" Checked="false"/> \
	</Menu>';

  csInterface.setPanelFlyoutMenu(flyoutXML);

  $("#ixTabs").tabs({ activate: adPointTab });

  csInterface.addEventListener(
    "com.adobe.csxs.events.flyoutMenuClicked",
    myFlyoutMenuClickedHandler
  );

  $("#debugButton").button();
  $("#debugButton").click(function () {
    scrap();
  });

  $("#ppSaveAndExportCustomButton").button();
  $("#ppSaveAndExportCustomButton").click(function () {
    ix_currentOpCode = "SaveAndExportCustomPP";
    doScript(
      "ix.handleExports",
      didExport,
      ix_currentOpCode,
      clientID,
      localStorage.ixApplicationName,
      "save"
    );
  });

  $("#saveAndExportCustomButton").button();
  $("#saveAndExportCustomButton").click(function () {
    ix_saveAndExportCustomButtonHandler();
  });

  $("#saveAndExportButton").button();
  $("#saveAndExportButton").click(function () {
    ix_saveAndExportButtonHandler();
  });

  $("#saveAsTemplateButton").button();
  $("#saveAsTemplateButton").click(function () {
    ix_saveAsTemplateButtonHandler();
  });

  $("#saveOnlyButton").button();
  $("#saveOnlyButton").click(function () {
    ix_saveOnlyButtonHandler();
  });

  $("#saveCloseButton").button();
  $("#saveCloseButton").click(function () {
    ix_saveCloseButtonHandler();
  });

  $("#btnClearLog").button({
    icons: { primary: "ui-icon-trash" },
    text: false,
  });
  $("#btnClearLog").tooltip({ content: "Clear log panel" });
  $("#btnClearLog").click(function () {
    // Clear log panel depended on which is selected
    const activeTab = $("#log-tabs").tabs("option", "active");

    switch (activeTab) {
      case 0:
        $("#logArea").empty();
        break;

      case 1:
        $("#logAreaOpenIndd").empty();
        break;

      default:
        break;
    }
  });

  $("#btnCfgInfo").button({ icons: { primary: "ui-icon-help" }, text: false });
  $("#btnCfgInfo").tooltip({ content: "Get Info" });
  $("#btnCfgInfo").click(function () {
    // var d = new Date();
    // // {weekday: 'long'}
    // var options = {
    //   weekday: "long",
    //   year: "numeric",
    //   month: "long",
    //   day: "numeric",
    // };
    // var today = d.toLocaleString(localStorage.ixLocale, options); //  test with   'da-DK'
    // var msgText =
    //   "Integration-X client (version " +
    //   localStorage.ixManifestVersion +
    //   ").\r";
    // msgText += today + "\r";
    // msgText += "API locale: " + window.navigator.language + "\r";
    // msgText += "InDesign locale: " + localStorage.ixLocale + "\r";

    const pluginVersion = localStorage.ixManifestVersion;
    const versonMsg = `Current version: ${pluginVersion}`;

    const copyRigtsMsg = `Copyrights: ©Integration X 2021`;

    markEndAction("");
    writePanel(versonMsg, MAIN_LOG_PANEL, undefined, undefined);
    writePanel(copyRigtsMsg, MAIN_LOG_PANEL, undefined, undefined);
    markEndAction("");
  });

  // our custom events from the JSX depths

  csInterface.addEventListener("IXLOG", function (evt) {
    console.log("Data from the jsx  IXLOG event=" + evt.data);
    if (evt.data == "CLEAR") {
      writeToExtensionConsole("", true);
    } else {
      writeToExtensionConsole(evt.data, false);
    }
  });

  csInterface.addEventListener("IXMSG", function (evt) {
    console.log("Data from the jsx  IXMSG event=" + evt.data);

    // action i.e., "open" $ "docPath" $ "PlanPoint || AdPoint" $ viewOnly = (true || false)

    var aTmp = evt.data.toString().split("$");

    if (aTmp[0] == "open") {
      if (aTmp[2] == "AdPoint") {
        $("#ixTabs").tabs("select", 0);

        //setAdPointButtonStates (aTmp[3]); // aTmp[3] = viewOnly (T || F)
      } else {
        if (aTmp[2] == "PlanPoint") {
          $("#ixTabs").tabs("select", 1);
        }
      }
      // REMOVED legacy code for opening indesign via sockets.
      // communicateDocumentOpened(aTmp[1], aTmp[2]);
    }

    if (aTmp[0] == "rerender") {
      doScript("ix.tryToRenderDocument", nada);
    }
    // if called from script menu
    if (aTmp[0] == "SaveAndExport") {
      ix_saveAndExportButtonHandler();
    }
    if (aTmp[0] == "SaveAndClose") {
      ix_saveCloseButtonHandler();
    }

    if (aTmp[0] == "SaveAndExportCustom") {
      ix_saveAndExportCustomButtonHandler();
    }

    if (aTmp[0] == "SaveOnly") {
      ix_saveOnlyButtonHandler();
    }

    if (aTmp[0] == "SaveAsTemplate") {
      ix_saveAsTemplateButtonHandler();
    }

    //  "tellPPopen"$+listOfPages+"$"
    if (aTmp[0] == "tellPPopen") {
      communicateTellPPOpen(aTmp[1]);
    }

    // 'tellADopen'$parentId$name
    if (aTmp[0] == "tellADopen") {
      // console.log("old params: ", aTmp[1], aTmp[2], aTmp[3]);
      // REMOVED legacy code for opening Indesign
      // aTmp[1] =  materialSpecification, aTmp[2] = folderName, aTmp[3] = bool
      // communicateTellADOpen(aTmp[1], aTmp[2], aTmp[3]);
      //if (aTmp[3]=="true") showViewOnlyWarning();
    }

    // {weekday: 'long'}
    //var options = { weekday: 'long', year: 'numeric', month: 'long', day: 'numeric' };

    if (aTmp[0] == "doCustomDate") {
      var d = new Date();
      var option = aTmp[1];
      var dateString = d.toLocaleString(window.navigator.language, option);
      doScript("ix.saveCustomDate", nada, dateString);
    }

    // getDateInfo$seedDate
    if (aTmp[0] == "getDateInfo") {
      gatherDateInfo(aTmp[1]);
    }
  });

  csInterface.addEventListener("IXIMPORTIMAGEPOST", function (evt) {
    console.log(
      "Got this data from the jsx  IXIMPORTIMAGEPOST event: " + evt.data
    );

    var arr = evt.data.split("%");
    if (arr.length == 2) {
      doScript("ix.importPostedImage", nada, arr[0], arr[1]);
    } else {
      console.log(
        " event listener IXIMPORTIMAGEPOST parse error " + arr.length
      );
    }
  });

  console.log(this);

  //var
  extensionRootPath = csInterface.getSystemPath(SystemPath.EXTENSION);

  console.log("index.js ready finish");

  writeToExtensionConsole("Integration-X client started OK.", false);

  //setTimeout(_ix_init_JSX, 10000);
  _ix_init_JSX();
  writeToExtensionConsole("Application code inited.", false);
});

function _ix_init_JSX() {
  doScript("ix.init", ixGotVersion, extensionRootPath); // init the JSX layer
}

function _getOut() {
  var csInterface = new CSInterface();
  csInterface.closeExtension();
}

function ix_saveAndExportCustomButtonHandler() {
  ix_currentOpCode = "SaveAndExportCustom";
  doScript(
    "ix.handleExports",
    didExport,
    ix_currentOpCode,
    clientID,
    localStorage.ixApplicationName,
    "save"
  );
}

function ix_saveAndExportButtonHandler() {
  ix_currentOpCode = "SaveAndExport";
  doScript(
    "ix.handleExports",
    didExport,
    ix_currentOpCode,
    clientID,
    localStorage.ixApplicationName,
    "save"
  );
}

function ix_saveAsTemplateButtonHandler() {
  ix_currentOpCode = "SaveTemplate";
  doScript(
    "ix.handleExports",
    didExport,
    ix_currentOpCode,
    clientID,
    localStorage.ixApplicationName,
    "save"
  );
}

function ix_saveOnlyButtonHandler() {
  ix_currentOpCode = "SaveOnly";
  doScript(
    "ix.handleExports",
    didExport,
    ix_currentOpCode,
    clientID,
    localStorage.ixApplicationName,
    "save"
  );
}

function ix_saveCloseButtonHandler() {
  ix_currentOpCode = "SaveClose";
  doScript(
    "ix.handleExports",
    didExport,
    ix_currentOpCode,
    clientID,
    localStorage.ixApplicationName,
    "save"
  );
}

function ixGotVersion(result) {
  var aTmp = result.split("$");

  if (aTmp[0] == "MODAL") {
    _getOut();
    return;
  }

  localStorage.ixManifestVersion = aTmp[0];
  //localStorage.ixApplicationName = aTmp[1];
  localStorage.ixApplicationName = "InDesign CC 2015";
  localStorage.ixLocale = aTmp[2];
  console.log("Integration-X version: " + localStorage.ixManifestVersion);
  console.log(localStorage.ixApplicationName);
  console.log(localStorage.ixLocale);
}

function writeToExtensionConsole(msg, clearFirst) {
  if (clearFirst == true) {
    $("#logArea").empty();
  }

  // var txt = $("#logArea").text();
  // txt = txt + msg + "\r";
  // $("#logArea").text(txt);

  writePanel(msg, MAIN_LOG_PANEL, undefined);
  console.log("writeToExtensionConsole: " + msg);
}

function gatherDateInfo(seed) {
  var d = new Date(seed);

  var weekday = d.toLocaleString(localStorage.ixLocale, { weekday: "long" });

  var year = d.toLocaleString(localStorage.ixLocale, { year: "numeric" });

  var month = d.toLocaleString(localStorage.ixLocale, { month: "long" });

  var day = d.toLocaleString(localStorage.ixLocale, { day: "numeric" });

  doScript("ix.saveDateInfo", nada, weekday, year, month, day);
}

function myFlyoutMenuClickedHandler(event) {
  // the event's "data" attribute is an object, which contains "menuId" and "menuName"
  console.dir(event);
  switch (event.data.menuId) {
    case "MENU_SHOW_HELP":
      console.log(event.data.menuName + " clicked!");
      csInterface.openURLInDefaultBrowser("http://www.integration-x.com");
      break;

    default:
      console.log(event.data.menuName + " unrecognized!");
      break;
  }
}

function ixOnQuit(evt) {
  doScript("ix.deinit", nada); // we quit before script finishes
}

function nada() {}

function didExport(result) {
  console.log("didExport " + result);
  if (result == "") {
    console.log("didExport error");
    return;
  }
  var aTmp = result.split("$");
  if (aTmp[0] == "0") return; //some kind of error

  ix_currentDocType = aTmp[1];

  // save, saveAndExport etc.
  const option = aTmp[2];
  communicateExport(aTmp[0], option);
}

function setAdPointButtonStates(viewOnly) {
  if (viewOnly == "true") {
    $("#saveAndExportButton").button("disable");
    $("#saveAndExportCustomButton").button("disable");
    $("#saveAsTemplateButton").button("disable");
    $("#saveOnlyButton").button("disable");
    $("#saveCloseButton").button("disable");
  } else {
    $("#saveAndExportButton").button("enable");
    $("#saveAndExportCustomButton").button("enable");
    $("#saveAsTemplateButton").button("enable");
    $("#saveOnlyButton").button("enable");
    $("#saveCloseButton").button("enable");
  }
}

function showViewOnlyWarning() {
  var langCode = navigator.language || navigator.userLanguage;

  var alertMsg =
    "You have chosen to review the ad and it is not possible to change it. ";
  if (langCode == "da" || langCode == "dan") {
    alertMsg = "Du har valgt kun at gennemse annoncen, den kan ikke opdateres.";
  }
  if (langCode == "fr" || langCode == "fre" || langCode == "fra") {
    alertMsg =
      "Vous avez choisi de revoir l'annonce, il n'est pas possible de la rédiger.";
  }
  if (langCode == "no" || langCode == "nn" || langCode == "nb") {
    alertMsg =
      "Du har valgt å kun se igjennom annonsen, og den kan ikke forandres.";
  }
  if (langCode == "sv" || langCode == "swe") {
    alertMsg = "Du har valt att bara granska annonsen och den kan inte ändras.";
  }

  doAlert2(alertMsg);
}

/*
function checkFileExists() {
   var path = "/Users/peterjbaumgartner/Documents/"+"myXMP.xml";
   console.log(path);
   if (!fs.existsSync(path)) {
      alert ("File does not exist");
   } else {
      alert ("File does exist");
   }
}
*/

function scrap() {
  debugger;
  var x =
    '<?xml version="1.0" encoding="UTF-8" standalone="no"?><response action="initialize" cid="1459421177032_1"  heartbeat_frequency="30000" timestamp="1459421177032"/>';

  var xmlData = makeXML(x);

  if (xmlData != null) {
    var action = xmlData.find("response").attr("action").toString();
    try {
      var parent = xmlData.find("response").attr("parent").toString();
    } catch (e) {
      console.log(" trapped err");
    }
  }

  if (action == "initialize") {
    console.log("  found");
  }

  //	<MenuItem Id="MENU_LOGOUT" Label="Logout" Enabled="true" Checked="false"/> \
  // <MenuItem Id="MENU_SETTINGS" Label="Settings" Enabled="true" Checked="false"/> \
  //	case "MENU_LOGOUT":

  //		break;

  //	case "MENU_SETTINGS":
  //		console.log(event.data.menuName + " clicked!");

  //		break;
}
